-- Demo 1:

USE AdventureWorks2017;

SELECT          p.ProductID,
                p.Name  AS ProductName,
                pm.Name AS ProductModelName,
                pm.ModifiedDate
FROM            Production.Product      AS p
LEFT OUTER JOIN Production.ProductModel AS pm
  ON            pm.ProductModelID = p.ProductModelID
WHERE           pm.ModifiedDate < '20120101';


-- Demo 2:

USE AdventureWorks2017;

SELECT AVG (p.ListPrice)
FROM   Production.Product AS p
WHERE  EXISTS
    (SELECT *
     FROM   Production.ProductInventory AS pi
     WHERE  pi.ProductID = p.ProductID
     AND    pi.ModifiedDate < '20120101');

SELECT AVG (p.ListPrice)
FROM   Production.Product AS p
WHERE  EXISTS
    (SELECT *
     FROM   Production.ProductModel AS pm
     WHERE  pm.ProductModelID = p.ProductModelID
     AND    pm.ModifiedDate      < '20120101');


-- Demo 3:

SELECT p.ProductID,
       p.ProductNumber,
       CASE WHEN EXISTS
                     (SELECT *
                      FROM   Production.ProductInventory AS pi
                      WHERE  pi.ProductID = p.ProductID
                      AND    pi.Quantity     > 500)
            THEN 'Yes'
            ELSE 'No'
       END AS HasHighInventory
FROM   Production.Product AS p
WHERE  p.ProductNumber LIKE 'FW%';
