-- Demo 1

USE AdventureWorks2017;

SELECT     soh.SalesOrderID,
           soh.TerritoryID,
           sod.SalesOrderDetailID,
           sod.SpecialOfferID
FROM       Sales.SalesOrderHeader AS soh
INNER JOIN Sales.SalesOrderDetail AS sod
   ON      soh.SalesOrderID = sod.SalesOrderID;

SELECT     soh.SalesOrderID,
           soh.TerritoryID,
           sod.SalesOrderDetailID,
           sod.ProductID
FROM       Sales.SalesOrderHeader AS soh
INNER JOIN Sales.SalesOrderDetail AS sod
   ON      soh.SalesOrderID = sod.SalesOrderDetailID
OPTION (MERGE JOIN, MAXDOP 1);


-- Demo 2

USE AdventureWorks2017;

SELECT          cr.Name,
                cr.CountryRegionCode,
                st.Name,
                st.TerritoryID
FROM            Person.CountryRegion AS cr
LEFT OUTER JOIN Sales.SalesTerritory AS st
  ON            cr.CountryRegionCode = st.CountryRegionCode;

SELECT           cr.Name,
                 cr.CountryRegionCode,
                 st.Name,
                 st.TerritoryID
FROM             Sales.SalesTerritory AS st
RIGHT OUTER JOIN Person.CountryRegion AS cr
   ON            cr.CountryRegionCode = st.CountryRegionCode;

-- Second window

SELECT *
INTO   dbo.NewCountryRegion
FROM   Person.CountryRegion AS cr;

SELECT          cr.Name,
                cr.CountryRegionCode,
                st.Name,
                st.TerritoryID
FROM            dbo.NewCountryRegion AS cr
LEFT OUTER JOIN Sales.SalesTerritory AS st
  ON            cr.CountryRegionCode = st.CountryRegionCode
OPTION (MERGE JOIN);

DROP TABLE dbo.NewCountryRegion;


-- Demo 3

USE AdventureWorks2017;

SELECT     cr.Name,
           cr.CountryRegionCode,
           st.Name,
           st.TerritoryID
FROM       Person.CountryRegion AS cr
INNER JOIN Sales.SalesTerritory AS st
   ON      cr.CountryRegionCode = st.CountryRegionCode
--ORDER BY   cr.CountryRegionCode
--ORDER BY   st.CountryRegionCode
--ORDER BY   st.TerritoryID
OPTION (MERGE JOIN);


-- Demo 4

USE AdventureWorks2017;

SELECT p.Name,
       p.Color,
       CASE WHEN EXISTS
                     (SELECT *
                      FROM   Sales.SalesOrderDetail AS sod
                      WHERE  sod.ProductID = p.ProductID)
                THEN 'Yes'
            ELSE 'No'
       END
FROM   Production.Product AS p
OPTION (MERGE JOIN);


-- Demo 5

USE AdventureWorks2017;

SELECT     soh.SalesOrderID,
           soh.OrderDate,
           sod.OrderQty,
           sod.ProductID
FROM       Sales.SalesOrderHeader AS soh
INNER JOIN Sales.SalesOrderDetail AS sod
   ON      sod.SalesOrderID = soh.SalesOrderID
   AND     sod.ModifiedDate > soh.ModifiedDate;


-- Demo 6

USE AdventureWorks2017;

SELECT soh.SalesOrderID,
       soh.CustomerID
FROM   Sales.SalesOrderHeader AS soh
UNION
SELECT sod.SalesOrderID,
       sod.SalesOrderDetailID
FROM   Sales.SalesOrderDetail AS sod;
