-- Preparation

USE ContosoRetailDW;

CREATE NONCLUSTERED COLUMNSTORE INDEX nci_FactOnlineSales
ON dbo.FactOnlineSales (OnlineSalesKey,
                        DateKey,
                        StoreKey,
                        ProductKey,
                        PromotionKey,
                        CurrencyKey,
                        CustomerKey,
                        SalesOrderNumber,
                        SalesOrderLineNumber,
                        SalesQuantity,
                        SalesAmount,
                        ReturnQuantity,
                        ReturnAmount,
                        DiscountQuantity,
                        DiscountAmount,
                        TotalCost,
                        UnitCost,
                        UnitPrice,
                        ETLLoadID,
                        LoadDate,
                        UpdateDate);


-- Demo 1

USE ContosoRetailDW;

SELECT     dc.FirstName,
           dc.MiddleName,
           dc.LastName,
           fos.SalesAmount
FROM       dbo.FactOnlineSales AS fos
INNER JOIN dbo.DimCustomer     AS dc
   ON      dc.CustomerKey = fos.CustomerKey
WHERE      fos.ProductKey = 1828;


-- Demo 2

USE ContosoRetailDW;

SELECT     dc.FirstName,
           dc.MiddleName,
           dc.LastName,
           fos.SalesAmount
FROM       dbo.FactOnlineSales AS fos
INNER JOIN dbo.DimCustomer     AS dc
   ON      dc.CustomerKey = fos.CustomerKey
WHERE      fos.ProductKey = 1828;
