-- Demo 1

USE AdventureWorks2017;

SELECT v.BusinessEntityID,
       v.Name
FROM   Purchasing.Vendor AS v
--UNION ALL
SELECT e.BusinessEntityID,
       e.JobTitle
FROM   HumanResources.Employee AS e
--UNION ALL
SELECT p.BusinessEntityID,
       p.LastName
FROM   Person.Person AS p;


-- Demo 2

USE AdventureWorks2017;

SELECT TOP (50) *
FROM
       (SELECT v.BusinessEntityID,
               v.Name
        FROM   Purchasing.Vendor AS v
        UNION ALL
        SELECT p.BusinessEntityID,
               p.LastName
        FROM   Person.Person AS p) AS sub;


-- Demo 3

-- Do this in tempdb to ensure all objects are gone upon the next restart
USE tempdb;
GO
CREATE VIEW dbo.v1 AS SELECT 1 AS a UNION ALL SELECT 1;
go
CREATE VIEW dbo.v2 AS SELECT * FROM dbo.v1 UNION ALL SELECT * FROM v1;
GO
CREATE VIEW dbo.v3 AS SELECT * FROM dbo.v2 UNION ALL SELECT * FROM v2;
GO
CREATE VIEW dbo.v4 AS SELECT * FROM dbo.v3 UNION ALL SELECT * FROM v3;
GO
CREATE VIEW dbo.v5 AS SELECT * FROM dbo.v4 UNION ALL SELECT * FROM v4;
GO
CREATE VIEW dbo.v6 AS SELECT * FROM dbo.v5 UNION ALL SELECT * FROM v5;
GO
CREATE VIEW dbo.v7 AS SELECT * FROM dbo.v6 UNION ALL SELECT * FROM v6;
GO
CREATE VIEW dbo.v8 AS SELECT * FROM dbo.v7 UNION ALL SELECT * FROM v7;
GO
CREATE VIEW dbo.v9 AS SELECT * FROM dbo.v8 UNION ALL SELECT * FROM v8;
GO
CREATE VIEW dbo.v10 AS SELECT * FROM dbo.v9 UNION ALL SELECT * FROM v9;
GO

-- Second window

SSMS, query window open on SQL 2022, tempdb.
SELECT * FROM dbo.v10;


-- Demo 4

-- Do this in tempdb to ensure all objects are gone upon the next restart
USE tempdb;
GO
CREATE TABLE dbo.T1
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 00 AND 24));

CREATE TABLE dbo.T2
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 25 AND 49));

CREATE TABLE dbo.T3
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 50 AND 74));

CREATE TABLE dbo.T4 
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 75 AND 99));

INSERT INTO dbo.T1 (c1)
VALUES (03), (11), (24);
INSERT INTO dbo.T2 (c1)
VALUES (26), (36), (40);
INSERT INTO dbo.T3 (c1)
VALUES (56), (57), (63);
INSERT INTO dbo.T4 (c1)
VALUES (75), (89), (95);

-- Second window

SELECT * FROM dbo.T1 WHERE c1 BETWEEN 10 AND 20
UNION ALL
SELECT * FROM dbo.T2 WHERE c1 BETWEEN 30 AND 40
UNION ALL
SELECT * FROM dbo.T3 WHERE c1 BETWEEN 60 AND 70
UNION ALL
SELECT * FROM dbo.T4 WHERE c1 BETWEEN 80 AND 90
--ORDER BY c1
--OPTION (CONCAT UNION);


-- Demo 5

USE AdventureWorks2017;

SELECT     ci.PersonID,
           p.Title,
           ci.FirstName,
           ci.LastName,
           ci.JobTitle,
           ci.BusinessEntityType
FROM       dbo.ufnGetContactInformation (17) AS ci
INNER JOIN Person.Person                     AS p
   ON      ci.PersonID = p.BusinessEntityID
--OPTION (USE HINT ('QUERY_OPTIMIZER_COMPATIBILITY_LEVEL_130'));


-- Demo 6

-- The code for this demo was created by Paul White.
-- Source: https://www.sql.kiwi/2013/06/hello-operator-my-switch-is-bored.html

-- Do this in tempdb to ensure all objects are gone upon the next restart
USE tempdb;
GO
/* These tables were already created in a previous demo
CREATE TABLE dbo.T1
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 00 AND 24));

CREATE TABLE dbo.T2
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 25 AND 49));

CREATE TABLE dbo.T3
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 50 AND 74));

CREATE TABLE dbo.T4 
   (c1 integer NOT NULL PRIMARY KEY
        CHECK (c1 BETWEEN 75 AND 99));
*/
-- A different view with this name might exist from a previous demo
DROP VIEW IF EXISTS dbo.V1;
GO
CREATE VIEW dbo.V1 WITH SCHEMABINDING
AS
SELECT c1 FROM dbo.T1
UNION ALL
SELECT c1 FROM dbo.T2
UNION ALL
SELECT c1 FROM dbo.T3
UNION ALL
SELECT c1 FROM dbo.T4;
GO

-- Second window

INSERT INTO dbo.V1
VALUES (31);
